/********************************************************/
/*      clindef.h					*/
/*	Definitions of Data Types and Macros		*/
/*                     T. Kurita       10-Jun-1990      */
/********************************************************/

/********************************************************/
/*	Standard Include files				*/
/********************************************************/
#include <stdio.h>
#include <math.h>

/*	External functions	*/
//extern	char *malloc();
//extern  void free();


/* Define the structure for the complex type. */
typedef struct {
	double real;
	double imag;
} complex;


/********************************************************/
/*	Macro Definitions				*/
/********************************************************/
/* Macro for LOGICAL VALUE */
#define	TRUE	1
#define	FALSE	0

/* Macro for epsilon */
#define	REPS	1.0e-10

/* Mathematical Constants */
#define	PI	3.14159265358979323846

/* Macro for print format */
#define RFMT	"%10.4f"
#define	IFMT	"%5d"

/* Macro for min and max */
#define	min(A,B)	((A) < (B) ? (A) : (B))
/* #define	max(A,B)	((A) > (B) ? (A) : (B)) */
#define abs(x)		((x) < 0 ? -(x) : (x))

/* Macros for MATRIX and VECTOR print */
#define	dmatprint(MAT,M,N,STRING) dmatpri(MAT,M,N,STRING,RFMT)
#define dvctprint(VCT,M,STRING)	dvctpri(VCT,M,STRING,RFMT)
#define	imatprint(MAT,M,N,STRING) imatpri(MAT,M,N,STRING,IFMT)
#define ivctprint(VCT,M,STRING)	ivctpri(VCT,M,STRING,IFMT)
#define	dmatprintf(FP,MAT,M,N,STRING) dmatprif(FP,MAT,M,N,STRING,RFMT)
#define dvctprintf(FP,VCT,M,STRING) dvctprif(FP,VCT,M,STRING,RFMT)
#define	imatprintf(FP,MAT,M,N,STRING) imatprif(FP,MAT,M,N,STRING,IFMT)
#define ivctprintf(FP,VCT,M,STRING) ivctprif(FP,VCT,M,STRING,IFMT)

/*	Macros for random */
#ifdef	MSDOS
#define	MAX_INTEGER	23768
#define	RAND	(double)rand()/MAX_INTEGER
#define IRAND(X)	rand()%(X)
#else
#define	MAX_INTEGER	2147483647
#define	RAND	(double)random()/(double)MAX_INTEGER		
#define IRAND(X)	random()%(X)
#endif


#define debugallocvct(x,y) malloc((x)*(y))
/************************************************/
/*      allocate resion for vectors		*/
/************************************************/
#define	allocivct(M)	(int *)debugallocvct(M,sizeof(int))
#define allocrvct(M)    (float *)debugallocvct(M,sizeof(float))
#define	allocdvct(M)	(double *)debugallocvct(M,sizeof(double))
#define	alloccvct(M)	(complex *)debugallocvct(M,sizeof(complex))

/************************************************/
/*      allocate resion for matrices  		*/
/************************************************/
#define	allocimat(M,N)	(int **)allocmat(M,N,sizeof(int))
#define allocrmat(M,N)  (float **)allocmat(M,N,sizeof(float))
#define	allocdmat(M,N)	(double **)allocmat(M,N,sizeof(double))
#define	alloccmat(M,N)	(complex **)allocmat(M,N,sizeof(complex))



